/* GCC */
#include <iostream>
#include <fstream>
using namespace std;

unsigned long long m;
int answers[100000];

bool prime(int number)
{
    for (int i = 2; i < number; i++)
    {
        if (number % i == 0)
        {
            return false;
        }
    }
    return true;
}

int countAndCheck(int number, int n)
{
    int counter = 2;
    for (int i = 2; i < number; i++)
    {
        if (number % i == 0)
        {
            counter++;
        }
        if (counter > n)
        {
            return -1;
        }
        if (prime(i))
        {
            if ((number % i == 0) && (m % i != 0))
            {
                return -1;
            }
        }
    }
    return counter;
}

int main()
{
    ifstream fin("divisors.in");
    ofstream fout("divisors.out");
    int n, counter = 0;
    fin >> m >> n;
    for (int i = 2; i < 12000; i++)
    {
        if (i % m == 0)
        {
            if (countAndCheck(i, n) == n)
            {
                //fout << i << endl;
                answers[counter] = i;
                counter++;
            }
        }
    }
    if (counter == 0)
    {
        fout << "0" << endl;
    }
    else
    {
        for (int i = 0; i < counter - 1; i++)
        {
            fout << answers[i] << " ";
        }
        fout << answers[counter - 1] << endl;
    }
    fin.close();
    fout.close();
    return 0;
}
