/* GCC */

#include <bits/stdc++.h>

using namespace std;

long long getDiv(long long m){
    long long c = 2;
    for(long long i = 2;i<m;i++)if(m%i==0) c++;
    return c;
}

vector<long long> getDivs(long long m){
    vector<long long> divs;
    for(long long i = 2;i<m;i++)if(m%i==0) divs.push_back(i);
    return divs;
}

int main()
{
    ifstream ifs;
    ofstream ofs;
    ifs.open("divisors.in");
    ofs.open("divisors.out");

    long long m,n;
    ifs >> m >> n;

    long long c = getDiv(m);

    long long mStart = m;
    while(c <= n){
        m*=mStart;
        c = c*2+1;
    }
    m/=mStart;
    c=getDiv(m);

    vector<long long> divsM = getDivs(mStart);
    vector<long long> ans;
    for(int i = 0;i<divsM.size();i++){
        long long d = getDiv(divsM[i]*m);
        if(d == n) ans.push_back(divsM[i]*m);
    }
    if(ans.size() == 0){
        ofs << 0 << endl;
    } else {
        for(int i = 0;i<ans.size();i++){
            ofs << ans[i] << " ";
        }
    }

    ifs.close();
    ofs.close();
}
