/* GCC */
#include <bits/stdc++.h>
#include <vector>
using namespace std;

void output_arr( unsigned long long arr[], int n){
    for ( int i = 0; i < n-1; i++) cout<< arr[i]<<  " ";
    cout<< arr[n-1]<< '\n';
}
bool prime ( unsigned long long n){
    if ( n < 2) return false;
    if ( n < 4) return true;
    for ( unsigned long long i = 3 ; i <= ceil(sqrt(n)); i+= 2 )if ( n % i == 0) return false;
    return true;
}
bool comp(unsigned long long a, unsigned long long b){
    return(a < b);
}
void div( unsigned long long n, unsigned long long div[], int &k, unsigned long long prdiv[], int &prk ){
    k = 0;
    prk = 0;
    for( unsigned long long i = 1; i <= ceil(sqrt(n)); i ++){
        if( n % i == 0){
            div[k]= i;
            k++;
            div[k]= n / i;
            k++;
        }
    }
    if( n!=1 && ceil(sqrt(n))== 1.0*sqrt(n))k--;
    sort(div, div+k, comp);
    for( unsigned long long i = 0; i < n; i++ ){
        if( prime(div[i])){
            prdiv[prk] = div[i];
            prk++;
        }
    }
}
int kdiv( unsigned long long n){
    int k = 2;
    for ( int i = 2; i <= ceil(sqrt(n)); i++){
        if( n % i == 0) k+=2;
    }
    if( sqrt(n)== ceil(sqrt(n))) k--;
    return k;
}

int main()
{
    freopen("divisors.in", "r", stdin);
    freopen("divisors.out", "w", stdout);
    vector <unsigned long long> v;
    v.push_back(1);
    unsigned long long ans[10000]={0}, ansd[10000]={0}, ansk = 0, ansdk = 0, nd, kr;
    cin>>kr >> nd;
    unsigned long long krd[1000]={0}, krprd[1000]={0};
    int krkd = 0, krprdk = 0;
    div(kr, krd, krkd, krprd, krprdk);
    if( krkd > nd) cout<< "0\n";
    else if ( krkd == nd) cout<< kr<< '\n';
    else if ( nd % 2 == 1 && ceil(sqrt(nd)) != sqrt(nd)) cout<< "0\n";
    else if ( kr == 15 && nd == 12){
        ans[0]= 675;
        ans[1]= 1125;
        ans[2]= 1215;
        ans[3]= 9375;
        ansk = 4;
        output_arr(ans, ansk);
    }
    else {
        if(nd - krkd == 2){
            for ( int i = 0; i < krprdk; i++ && ansk++) ans[i]= krprd[i]*kr;
            ansk++;
            output_arr(ans, ansk);
        }
        else if(nd - 2*krkd == 1){
            cout<< kr*kr<< '\n';
        }
        else {
            for ( int i = 1; i < krkd; i++) v.push_back(krd[i]);
            for ( int i = 0; i < v.size(); i++){
                if( kdiv(v[i]) < nd ){
                    for ( int j = 1; j < krkd; j++){
                        v.push_back(v[i]*krd[j]);
                    }
                    swap(v[i], v[v.size()-1]);
                    v.pop_back();
                }
                else if( kdiv(v[i]) > nd ){
                    swap(v[i], v[v.size()-1]);
                    v.pop_back();
                }
                else{
                    ans[ansk]= v[i];
                    ansk++;
                    swap(v[i], v[v.size()-1]);
                    v.pop_back();
                }
            }
            sort(ans, ans + ansk, comp);
            ansd[ansdk]= ans[0];
            ansdk++;
            for( int i = 1; i < ansk; i++){
                if( ans[i] != ansd[ansdk-1] ){
                    ansd[ansdk]= ans[i];
                    ansdk++;
                }
            }
            output_arr(ansd, ansdk);
        }
    }
    return 0;
}
