/* GCC */
#include<iostream>
#include<cstdio>
#define ll long long

using namespace std;

const int N = 1e6 + 1, K = 10 + 1;
const ll inf = 4e18;

int n, a, b, k;

ll m[N][K];
ll solve(int n, int k){
    if(n == 1)
        return 0;
    if(k == 0)
        return inf;
    if(m[n][k] != -1)
        return m[n][k];
    ll ans = inf;
    for(int i = 1; i < n; ++i)
        ans = min(ans, max(solve(n-i, k) + a, solve(i, k-1) + b));
    return m[n][k] = ans;
}

int main(){
    freopen("cash.in", "r", stdin);
    freopen("cash.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
    cin >> n >> a >> b >> k;
    for(int i = 0; i <= n; ++i)
        for(int j = 0; j <= k; ++j)
            m[i][j] = -1;
    cout << solve(n, k) << endl;
}
