/* GCC */
#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

#define int long long

const int N=1e6+10,K=11,INF=1e13;

int dp[N][K];

signed main()
{
    #define name "cash"
    freopen(name".in","r",stdin);
    freopen(name".out","w",stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n,a,b,k;
    cin>>n>>a>>b>>k;
    int s=N/n/3+3;
    for(int i=2;i<=n;i++)
        dp[i][0]=INF;
    for(int i=2;i<=n;i++)
        for(int j=1;j<=k;j++)
        {
            dp[i][j]=INF;
            int l=1,r=i-1;
            while(r-l>s)
            {
                int t1=(l*2+r)/3;
                int t2=(r*2+l)/3;
                int res1=max(a+dp[i-t1][j],
                             b+dp[t1][j-1]);
                int res2=max(a+dp[i-t2][j],
                             b+dp[t2][j-1]);
                dp[i][j]=min(dp[i][j],res1);
                dp[i][j]=min(dp[i][j],res2);
                if(res1<res2)
                    r=t2;
                else
                    l=t1;
            }
            for(int t=l;t<=r;t++)
                dp[i][j]=min(dp[i][j],max(a+dp[i-t][j],
                                          b+dp[t][j-1]));
            for(int t=1;t<=min(i-1,s);t++)
                dp[i][j]=min(dp[i][j],max(a+dp[i-t][j],
                                          b+dp[t][j-1]));
            for(int t=max(1ll,i-s);t<=i-1;t++)
                dp[i][j]=min(dp[i][j],max(a+dp[i-t][j],
                                          b+dp[t][j-1]));
        }
    cout<<dp[n][k]<<"\n";
}
