/* GCC */
#include <bits/stdc++.h>
#define pb push_back
#define f first
#define s second

using namespace std;

typedef long long ll;
typedef pair<ll,ll> pll;
typedef vector < ll > vll;

const ll inf = 1000000000000000;
vector <vll> d;

ll bins(vll v, ll a, ll b, ll j)
{
    ll l = 1, r = j;
    if(r == l+1)
    {
        r--;
        ll z1 = max(v[j-l]+a,v[l]+b);
        ll z2 = max(v[j-r]+a,v[r]+b);
        return min(z1,z2);
    }
    while(r-l>1)
    {
        ll m = (l+r)/2;
        ll z1 = inf, z2 = inf;
        ll z0 = max(v[j-m]+a,v[m]+b);
        if(m>1) z1 = max(v[j-m+1]+a,v[m-1]+b);
        if(m<j-1) z2 = max(v[j-m-1]+a,v[m+1]+b);
        if(z0<z1 && z0<z2) return z0;
        else if(z0>z1) r = m;
        else l = m;
    }
    if(r==j) return max(v[j-r]+a,v[r]+b);
    else return max(v[j-l]+a,v[l]+b);
}

int main()
{
    freopen("cash.in","r",stdin);
    freopen("cash.out","w",stdout);
    ll n, a, b, k;
    cin >> n >> a >> b >> k;
    d.resize(k);
    d[0].pb(0);
    if(n>2400){
    d[0].pb(0);
    for(ll i = 2; i<=n; i++)
    {
        d[0].pb((i-2)*a + b);
    }
    for(ll i = 1; i<k; i++)
    {
        d[i].pb(0);
        d[i].pb(0);
        for(ll j = 2; j<=n; j++)
        {
            d[i].pb(bins(d[i-1],a,b,j));
        }
    }
    cout << d[k-1][n] << '\n';
    }
    else
    {
        for(ll i = 1; i<n; i++)
        {
            d[0].pb((i-1)*a + b);
        }
        for(ll i = 1; i<k; i++)
        {
            d[i].pb(0);
            for(ll j = 1; j<n; j++)
            {
                ll _m = 10000000000000000;
                for(ll x = 0; x<j; x++)
                {
                    ll t = max(d[i-1][j-x-1]+a,d[i-1][x]+b);
                    if(t<_m) _m = t;
                }
                d[i].pb(_m);
            }
        }
        cout << d[k-1][n-1] << '\n';
    }
    fclose(stdin);
    fclose(stdout);
}
