/* GCC */
#include <bits/stdc++.h>

using namespace std;

const int nmax = 100000;

int resheto[nmax];
vector<int> simple[12007];
vector<int> answer;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    freopen("divisors.in", "r", stdin);
    freopen("divisors.out", "w", stdout);
    unsigned long long m;
    int n;
    cin >> m >> n;
    resheto[1]=1;
    for(int i = 2; i < 12000; ++i){
        resheto[i]+=2;
    }
    for(int i = 2; i < 12000; ++i){
        if (resheto[i] == 2) simple[i].push_back(i);
        for(int j = i+i; j < 12000; j+=i){
            resheto[j]++;
            if (resheto[i] == 2){
                simple[j].push_back(i);
            }
        }
    }

    for (int i = m; i < 12000; i+=m){
        bool flag = false;
        if (resheto[i] == n)
            if (simple[i].size() == simple[m].size()){
                flag = true;
                for(int j = 0; i < simple[i].size() && flag; ++j)
                    if (simple[i][j] != simple[m][j]) flag = false;
            }
        if (flag) answer.push_back(i);
    }

    if (answer.size() == 0) cout << 0 << '\n';
    else{
        for(int i = 0; i < answer.size() - 1; ++i)
            cout << answer[i] << ' ';
        cout << answer[answer.size()-1] << '\n';
    }

    return 0;
}
