/* GCC */
#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

vector < long long > p;
vector < long long > s;
vector < long long > res;
long long n;

void Makep(long long a) {
     long long i;
     long long t = a;
     p.push_back(0);
     s.push_back(0);
     if (a%2==0) {
        p.push_back(2);
        s.push_back(2);
        p[0]++;
        a/=2;
        while (a%2==0) {
              s[p[0]]++;
              a/=2;
        }    
     }
     for (i=3; i*i<=t; i+=2) {
         if (a==1) break;
         if (a%i==0) {
            p.push_back(i);
            s.push_back(2);
            p[0]++;
            a/=i;
            while (a%i==0) {
                  s[p[0]]++;
                  a/=i;      
            }
         }
     }
     if (a!=1) {
        p[0]++;
        p.push_back(a);
        s.push_back(2);
     }
}

void Print() {
     for (long long i=1; i<=p[0]; i++)
         cout<<p[i]<<"^"<<s[i]<<endl;     
}

long long pow(long long a, long long n) {
     long long x = 1;
     for (long long i=1; i<n; i++)
         x*=a;
     return x;
}

void Rec(long long curr, long long Mul, long long val) {
     if (curr==p[0]) {
        long long x = n / Mul;
        if (x>=s[p[0]]) {
           res.push_back(val*pow(p[p[0]],x));
           res[0]++;
        }
        return;                
     }
     for (long long x = 0; s[curr]+x<=(n/Mul); x++) {
         if ((n/Mul)%(s[curr]+x)==0) {
            Rec(curr+1,Mul*(s[curr]+x),val*pow(p[curr],s[curr]+x));     
         }
     }     
}

int main() {
    freopen("divisors.in","r",stdin);
    freopen("divisors.out","w",stdout);   
    long long m;
    cin>>m>>n;
    Makep(m);
    res.push_back(0);
    //Print();
    Rec(1,1,1);
    sort(res.begin() + 1, res.end());
    if (res[0]==0) cout<<0<<endl; else {
       for (long long i=1; i<res[0]; i++)
           cout<<res[i]<<" ";
       cout<<res[res[0]]<<endl;
    }
}
