/* GCC */

#include <fstream>
#include <cmath>
#include <iostream>
#include <climits>

int n = 0, a = 0, b = 0, k = 0;

int findResult(int n, int a, int b, int k)
{
    if(n <= 1) return 0;
    if(k == 1) return (n - 2) * a + b;
    int maxSafe = pow(2, k);
    int out = b * n;
    maxSafe = std::min(maxSafe, (int) n / 2 + 1);
    for(int i = 1; i <= std::min(maxSafe, n); i++)
    {
        out = std::min(out, std::max(findResult(n - i, a, b, k) + a,  findResult(i, a, b, k - 1) + b));
    }
    return out;
}

int main()
{
    std::ifstream in("cash.in");
    std::ofstream out("cash.out");

    in >> n >> a >> b >> k;

    out << std::fixed << findResult(n, a, b, k);

    return 0;
}
