/* GCC */
#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

using namespace std;

#define ll long long
#define pii pair<int,int>

#define MAXN 500100
#define MAXX 12000
#define INF 2000000000
#define MOD 1000000007

ll n, m;

ll GCD(ll a, ll b)
{
    while ((a != 0) && (b != 0)){
        if (a == 1) return 1;
        if (b == 1) return 1;
        if (a < b) b %= a;
        else a %= b;
    }
    return a+b;
}

bool for_m(ll x)
{
    ll mm = m;
    if (x == 1) return true;
    if ((mm % x) == 0) return true;

    ll d = GCD(mm, x);
    while (d != 1){
        mm = d;
        x = x/d;
        d = GCD(mm, x);
    }
    if (x == 1) return true;
    return false;
}

int main(void)
{
    freopen("divisors.in", "r", stdin);
    freopen("divisors.out", "w", stdout);

    cin >> m >> n;

//    cout << GCD(m, n) << "\n";
/*
    if (!for_m(n))
        cout << "0\n";
    else
        cout << "1\n";
*/


    ll div, first=0, d;
    for (ll i=1; i*m<MAXX; i++){
        if (!for_m(i)) continue;

        div = 0;
        for (d=1; d*d<=(i*m); d++){
            if ((i*m) == (d*d)) { div++; continue; }
            if (((m*i)%d) == 0) div += 2;
        }

        if ((i == 1) && (div > n)){
            cout << "0\n";
            return 0;
        }

        if (div == n){
            if (first == 0){
                cout << m*i;   // cout << "\n";
                first = 1;
            }
            else cout << " " << m*i;    // cout << "\n";
        }
    }

    if (first == 0) cout << "0";

    cout << "\n";

    return 0;
}

