/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

long long f(long long n, long long k) {
     if (n==1) return(n);
     if (k==2) return (n-1);
     long long res = 1, curr=1;
     for (long long i=1; i<=n-1; i++) {
         curr*=(k-1);
         res+=curr;
     }
     return (res-1);     
}

long long result(long long n, long long k) {
     long long res = 0;
     for (long long i=1; i<=k; i++)
         res+=f(n,i);
     return res;     
}

int main() {
    freopen("marks.in","r",stdin);
    freopen("marks.out","w",stdout);   
    long long n, k;
    cin>>n>>k;
    long long res=0;
    for (long long i=1; i*i<=n; i++) {
        if (n%i!=0) continue;
        res+=result(i,k);
        if (i*i!=n) res+=result(n/i,k);
    }
    cout<<res<<endl;
}
