/* GCC */
#include <iostream>
#include <cstdio>

using namespace std;

long long n,a,b,k;
long long ans;
long long dp[1000010][12];

long long fnc(long p,long t,long k){
    return max(dp[t-p][k]+a,dp[p][k-1]+b);
}

int main()
{
    freopen("cash.in","r",stdin);
    freopen("cash.out","w",stdout);
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    cin >> n >> a >> b >> k;
    ans = (n-2) * a + min(a,b);
    for(long i = 1;i <= k;i++)
        dp[1][i] = 0;
    if(n*k*100 >= 10000*10000){
        for(long i = 1;i <= k;i++)
            dp[2][i] = max(a,b);
        for(long i = 3;i <= n;i++){
            dp[i][1] = (i-2)*a+max(a,b);
            if(i % 2 == 0){
                for(long j = 2;j <= k;j++){
                    dp[i][j] = (i-2)*a+max(a,b);
                    dp[i][j] = min(dp[i][j-1],dp[i][j]);
                    dp[i][j] = min(dp[i-1][j]+a,dp[i][j]);
                    dp[i][j] = min(max(dp[i/2][j-1]+b,dp[i/2][j]+a),dp[i][j]);
                }
            }else{
                for(long j = 2;j <= k;j++){
                    dp[i][j] = (i-2)*a+max(a,b);
                    dp[i][j] = min(dp[i][j-1],dp[i][j]);
                    dp[i][j] = min(dp[i-1][j]+a,dp[i][j]);
                    dp[i][j] = min(max(dp[i/2][j-1]+b,dp[i/2+1][j]+a),dp[i][j]);
                    dp[i][j] = min(max(dp[i/2+1][j-1]+b,dp[i/2][j]+a),dp[i][j]);
                }
            }
        }
    }else if(n*n*k*20 >= 10000*10000){
        for(long i = 2;i <= n;i++){
            dp[i][1] = (i-2)*a+max(a,b);
            for(long j = 2;j <= k;j++){
                dp[i][j] = (i-2)*a+max(a,b);
                long l = 0,r = i;
                while(r - l > 1){
                    long tl = l + (r-l+1)/3;
                    long tr = r - (r-l+1)/3;
                    if(fnc(tr,i,j) > fnc(tl,i,j))r = tr;
                    else l = tl;
                }
                long start = max(1l,l-20);
                long to = min(i-1,start+40);
                for(long kek = start;kek <= to;kek++)
                    dp[i][j] = min(dp[i][j],fnc(kek,i,j));
            }
        }
    }else{
        for(long i = 1;i <= k;i++)
            dp[2][i] = max(a,b);
        for(long i = 3;i <= n;i++){
            dp[i][1] = (i-2)*a+max(a,b);
            for(long j = 2;j <= k;j++){
                dp[i][j] = (i-2)*a+max(a,b);
                for(long t = 1;t <= i-1;t++){
                    long long last = dp[i][j];
                    dp[i][j] = min(dp[i][j],max(dp[t][j-1]+b,dp[i-t][j]+a));
                }
            }
        }
    }
    cout << dp[n][k] << '\n';
    return 0;
}
//20 300 400 10
//12 300 400 10
//5 300 400 10
//564 3644  9872 9
//4589 3249 9873 8
