/* GCC */
#include <iostream>
#include <fstream>
#include <cmath>

using namespace std;

bool isSimpleDel(unsigned long long number) {

    unsigned long long checker = sqrt(number) + 1;
    unsigned long long i;

    cout << number << " ";

    for (i = 2; i < checker; i++) {
        if (number % i == 0) {cout << false << endl; return false;}
    }

    cout << true << endl;
    return true;

}


bool isMyNumber(unsigned long long number, short expectedDelsAmount, unsigned long long m) {
    unsigned long long i;
    short delsAmount = 1;

    unsigned long long checker = number / 2 + 1;

    for (i = 2; i < checker; i++) {
        if (number % i == 0) {
            if (isSimpleDel(i) && (m % i != 0)) return false;
            delsAmount++;
        }
        if (delsAmount > expectedDelsAmount) return false;
    }

    return delsAmount == expectedDelsAmount;
}


int main() {
    ifstream input ("divisors.in");
    ofstream output ("divisors.out");

    unsigned long long m, i;
    short expectedDelsAmount;
    bool isExistingExpectedNumbers = false;
    input >> m >> expectedDelsAmount;
    unsigned long long checker = m / 2 + 1;

    for (i = m; i < 12000; i+=m) {
        if (isMyNumber(i, expectedDelsAmount, m)) {
            isExistingExpectedNumbers = true;
            output << i << " ";
        }
    }

    if (!isExistingExpectedNumbers) output << 0;

    output << endl;

    return 0;
}
